# List Fields

> Source: https://truto.one/docs/api-reference/unified-crm-api/fields/list/

`GET /unified/crm/fields`

Resource: **Fields** · API: **Unified CRM API**

## Supported integrations

Affinity, Attio (partial), Capsule, Close, Microsoft Dynamics 365 Sales (partial), Freshsales, Highlevel, HubSpot, Insightly, Monday CRM, Nutshell, OnePageCRM, Pipedrive, Planhat, Salesflare, Salesforce (partial), Zendesk Sell, Zoho CRM

## Query parameters

- **`integrated_account_id`** _(string, required)_
  The ID of the integrated account to use for the request.
- **`truto_response_format`** _(string)_
  The format of the response. - `unified` returns the response with unified mappings applied. - `raw` returns the unprocessed, raw response from the remote API. - `normalized` applies the unified mappings and returns the data in a normalized format. - `stream` returns the response as a stream, which is ideal for transmitting large datasets, files, or binary data. Using streaming mode helps to efficiently handle large payloads or real-time data flows without requiring the entire data to be buffered in memory. Defaults to `unified`.
  Allowed: `unified`, `raw`, `normalized`, `stream`
- **`truto_key_by`** _(string)_
  By default the `result` attribute is an array of objects. This parameter allows you to specify a field in each `result` objects to use as key, which transforms the `result` array into an object with the array items keyed by the field. This is useful for when you want to use the result as a lookup table.
- **`truto_ignore_limit`** _(boolean)_
  Ignores the `limit` query parameter.
- **`truto_ignore_remote_data`** _(boolean)_
  Excludes the `remote_data` attribute from the response.
- **`truto_exclude_fields`** _(array<string>)_
  Array of fields to exclude from the response.
- **`remote_query`** _(object)_
  Query parameters to pass to the underlying API without any transformations. Refer [this guide](https://truto.one/docs/api-reference/overview/querying#remote-query-parameters) to see how to structure the query parameters.
- **`entity`** _(string)_
  Allowed: `account`, `contact`, `lead`, `note`, `opportunity`, `project`, `task`, `view`
- **`workspace`** _(object)_
- **`sort_by`** _(enum)_
  Allowed: `name`
- **`name`** _(string)_
  The field's name. This is the name of the property in the entity.

## Response body

- **`result`** _(array<object>)_
  List of Fields
  - **`id`** _(string)_
    The field's unique identifier
  - **`name`** _(string)_
    The field's name. This is the name of the property in the entity.
  - **`label`** _(string)_
    The field's label
  - **`description`** _(string)_
    The field's description
  - **`type`** _(string)_
    The field's type
    Allowed: `string`, `text`, `rich_text`, `number`, `boolean`, `date`, `datetime`, `time`, `enum`, `array`, `file`, `address`
  - **`is_hidden`** _(boolean)_
    Whether the field is hidden
  - **`is_unique`** _(boolean)_
    Whether the field is unique
  - **`is_required`** _(boolean)_
    Whether the field is required
  - **`is_editable`** _(boolean)_
    Whether the field is editable
  - **`options`** _(array<object>)_
    The field's options
    - **`label`** _(string)_
      The option's label
    - **`value`** _(string)_
      The option's value
    - **`description`** _(string)_
      The option's description
    - **`is_hidden`** _(boolean)_
      Whether the option is hidden
  - **`is_user_defined`** _(boolean)_
    Whether the field is user defined
  - **`entity_type`** _(string)_
    The entity type the field belongs to
    Allowed: `contact`, `account`, `opportunity`
  - **`reference_entity`** _(string)_
    The entity type this field references to
    Allowed: `contact`, `account`, `opportunity`, `lead`
  - **`field_groups`** _(array<object>)_
    - **`id`** _(string)_
      The field group's unique identifier
    - **`name`** _(string)_
      The field group's name
  - **`created_at`** _(string)_
    The date and time of the field's creation
  - **`updated_at`** _(string)_
    The date and time of the field's last update
  - **`urls`** _(array<object>)_
    The field's urls
    - **`url`** _(string)_
      The field's URL
    - **`type`** _(string)_
      The field's URL type
  - **`remote_data`** _(object)_
    Raw data returned from the remote API call.
- **`next_cursor`** _(string)_
  The cursor to use for the next page of results. Pass this value as `next_cursor` in the query parameter in the next request to get the next page of results.

## Code examples

### curl

```bash
curl -X GET 'https://api.truto.one/unified/crm/fields?integrated_account_id=<integrated_account_id>' \
  -H 'Authorization: Bearer <your_api_token>' \
  -H 'Content-Type: application/json'
```

### JavaScript

```javascript
const integratedAccountId = '<integrated_account_id>';

const response = await fetch(`https://api.truto.one/unified/crm/fields?integrated_account_id=${integratedAccountId}`, {
  method: 'GET',
  headers: {
    'Authorization': 'Bearer <your_api_token>',
    'Content-Type': 'application/json',
  },
});

const data = await response.json();
console.log(data);
```

### Python

```python
import requests

url = "https://api.truto.one/unified/crm/fields"
headers = {
    "Authorization": "Bearer <your_api_token>",
    "Content-Type": "application/json",
}
params = {
    "integrated_account_id": "<integrated_account_id>"
}

response = requests.get(url, headers=headers, params=params)
print(response.json())
```

### Truto TS SDK

```typescript
import Truto from '@truto/truto-ts-sdk';

const truto = new Truto({
  token: '<your_api_token>',
});

const result = await truto.unifiedApi.list(
  'crm',
  'fields',
  { integrated_account_id: '<integrated_account_id>' }
);

console.log(result);
```

### Truto Python SDK

```python
import asyncio
from truto_python_sdk import TrutoApi

truto_api = TrutoApi(token="<your_api_token>")

async def main():
    async for item in truto_api.unified_api.list(
        "crm",
        "fields",
        {"integrated_account_id": "<integrated_account_id>"}
    ):
        print(item)

asyncio.run(main())
```
